-module(trace_test).

-export([run/0,run/1,tracer/0,chunk/0]).

-include("src/luerl.hrl").
-include("src/luerl_instrs.hrl").

run() ->
    run(chunk()).

run(Chunk) ->
    Tracer = tracer(),
    St0 = luerl_new:init(),
    St1 = luerl_new:set_trace_func(Tracer, St0),
    St2 = luerl_new:set_trace_data([], St1),	%Initialise the trace data
    {ok,Ret,St3} = luerl_new:do(Chunk, [return,{file,"the-chunk"}], St2),
    Data = luerl_new:get_trace_data(St3),
    {Ret,Data,St3}.
    
tracer() ->
    fun (?FCALL, #luerl{stk=Stk,trace_data=Td}=St) ->
	    [Args,Func|_] = Stk,
	    io:format("~p ~p ~p\n", [?FCALL,Func,Args]),
	    St#luerl{trace_data=Td++[?FCALL]};
	(I, #luerl{trace_data=Td}=St) ->
	    %% io:format("~p\n", [I]),
	    St#luerl{trace_data=Td++[I]}
    end.

chunk() ->
    <<
"local a = function (v) return {m = v} end

x = a(21)
x.m = 42
y = a(21)

print(x, y)
print(x.m, y.m)

return x
"
>>.
